#include "blocks.h"

/* Set 'sz' 'int's beginning at 'd' to the value 'c' */
/* Returns address of block.  Does nothing if 'sz' equals zero */

int *msetI(register int *d, register int c, register int sz)
{
	int *orgd=d;

	while (sz>=16)
	{
		d[0]=c; d[1]=c; d[2]=c; d[3]=c; d[4]=c; d[5]=c; d[6]=c; d[7]=c;
		d[8]=c; d[9]=c; d[10]=c; d[11]=c; d[12]=c; d[13]=c; d[14]=c; d[15]=c;
		d+=16;
		sz-=16;
	}
	switch (sz)
	{
		case 15: d[14]=c;
		case 14: d[13]=c;
		case 13: d[12]=c;
		case 12: d[11]=c;
		case 11: d[10]=c;
		case 10: d[9]=c;
		case 9: d[8]=c;
		case 8: d[7]=c;
		case 7: d[6]=c;
		case 6: d[5]=c;
		case 5: d[4]=c;
		case 4: d[3]=c;
		case 3: d[2]=c;
		case 2: d[1]=c;
		case 1: d[0]=c;
		case 0:;
	}
	return orgd;
}

/* Set 'sz' 'char's beginning at 'd' to the value 'c' */
/* Returns address of block.  Does nothing if 'sz' equals zero */

char *mset(register char *d, register unsigned char c, register int sz)
{
	char *orgd=d;

	if (sz<16)
		switch (sz)
		{
			case 15: d[14]=c;
			case 14: d[13]=c;
			case 13: d[12]=c;
			case 12: d[11]=c;
			case 11: d[10]=c;
			case 10: d[9]=c;
			case 9: d[8]=c;
			case 8: d[7]=c;
			case 7: d[6]=c;
			case 6: d[5]=c;
			case 5: d[4]=c;
			case 4: d[3]=c;
			case 3: d[2]=c;
			case 2: d[1]=c;
			case 1: d[0]=c;
			case 0:;
		}
	else
	{
		int z=4-((int) d&3);

		if (z!=4)
			switch (z)
			{
				case 7: d[6]=c;
				case 6: d[5]=c;
				case 5: d[4]=c;
				case 4: d[3]=c;
				case 3: d[2]=c;
				case 2: d[1]=c;
				case 1: d[0]=c;
				case 0:;
				d+=z;
				sz-=z;
			}
		msetI ((int *) d, (c<<24)+(c<<16)+(c<<8)+c, sz>>2);
		d+=sz&~3;
		switch (sz&3)
		{
			case 7: d[6]=c;
			case 6: d[5]=c;
			case 5: d[4]=c;
			case 4: d[3]=c;
			case 3: d[2]=c;
			case 2: d[1]=c;
			case 1: d[0]=c;
			case 0:;
		}
	}
	return orgd;
}

/* Copy a block of integers */
/* Copy from highest address to lowest */

static int *mbkwdI(register int *d, register int *s, register int sz)
{
	if (d==s)
		return d;
	d+=sz;
	s+=sz;
	while (sz>=16)
	{
		d-=16;
		s-=16;
		d[15]=s[15]; d[14]=s[14]; d[13]=s[13]; d[12]=s[12]; d[11]=s[11]; d[10]=s[10];
		d[9]=s[9]; d[8]=s[8]; d[7]=s[7]; d[6]=s[6]; d[5]=s[5]; d[4]=s[4]; d[3]=s[3];
		d[2]=s[2]; d[1]=s[1]; d[0]=s[0];
		sz-=16;
	}
	d-=sz;
	s-=sz;
	switch (sz)
	{
		case 15: d[14]=s[14];
		case 14: d[13]=s[13];
		case 13: d[12]=s[12];
		case 12: d[11]=s[11];
		case 11: d[10]=s[10];
		case 10: d[9]=s[9];
		case 9: d[8]=s[8];
		case 8: d[7]=s[7];
		case 7: d[6]=s[6];
		case 6: d[5]=s[5];
		case 5: d[4]=s[4];
		case 4: d[3]=s[3];
		case 3: d[2]=s[2];
		case 2: d[1]=s[1];
		case 1: d[0]=s[0];
		case 0:;
	}
	return d;
}

/* Copy a block of 'int's.  Copy from lowest address to highest */

static int *mfwrdI(register int *d, register int *s, register int sz)
{
	int *od=d;

	if (s==d)
		return d;
	while (sz>=16)
	{
		d[0]=s[0]; d[1]=s[1]; d[2]=s[2]; d[3]=s[3]; d[4]=s[4]; d[5]=s[5]; d[6]=s[6];
		d[7]=s[7]; d[8]=s[8]; d[9]=s[9]; d[10]=s[10]; d[11]=s[11]; d[12]=s[12];
		d[13]=s[13]; d[14]=s[14]; d[15]=s[15];
		s+=16;
		d+=16;
		sz-=16;
	}
	s-=15-sz;
	d-=15-sz;
	switch (sz)
	{
		case 15: d[0]=s[0];
		case 14: d[1]=s[1];
		case 13: d[2]=s[2];
		case 12: d[3]=s[3];
		case 11: d[4]=s[4];
		case 10: d[5]=s[5];
		case 9: d[6]=s[6];
		case 8: d[7]=s[7];
		case 7: d[8]=s[8];
		case 6: d[9]=s[9];
		case 5: d[10]=s[10];
		case 4: d[11]=s[11];
		case 3: d[12]=s[12];
		case 2: d[13]=s[13];
		case 1: d[14]=s[14];
		case 0:;
	}
	return od;
}

/* Copy the block of 'sz' bytes beginning at 's' to 'd'.  If 'sz' is zero or
 * if 's'=='d', nothing happens.  The bytes at the highest address ('s'+'sz'-1)
 * are copied before the ones at the lowest ('s') are.
 */

char *mbkwd(register char *d, register char *s, register int sz)
{
	if (s==d)
		return d;
	s+=sz;
	d+=sz;
	if (((int) s&3)==((int) d&3) && sz>=16)
	{
		int z=((int) s&3);

		s-=z;
		d-=z;
		switch (z)
		{
			case 7: d[6]=s[6];
			case 6: d[5]=s[5];
			case 5: d[4]=s[4];
			case 4: d[3]=s[3];
			case 3: d[2]=s[2];
			case 2: d[1]=s[1];
			case 1: d[0]=s[0];
			case 0:;
		}
		sz-=z;
		mbkwdI ((int *) (d-(sz&~3)), (int *) (s-(sz&~3)), sz>>2);
		d-=sz;
		s-=sz;
		switch (sz&3)
		{
			case 7: d[6]=s[6];
			case 6: d[5]=s[5];
			case 5: d[4]=s[4];
			case 4: d[3]=s[3];
			case 3: d[2]=s[2];
			case 2: d[1]=s[1];
			case 1: d[0]=s[0];
			case 0:;
		}
	}
	else
	{
		while (sz>=16)
		{
			d-=16;
			s-=16;
			d[15]=s[15]; d[14]=s[14]; d[13]=s[13]; d[12]=s[12]; d[11]=s[11]; d[10]=s[10];
			d[9]=s[9]; d[8]=s[8]; d[7]=s[7]; d[6]=s[6]; d[5]=s[5]; d[4]=s[4]; d[3]=s[3];
			d[2]=s[2]; d[1]=s[1]; d[0]=s[0];
			sz-=16;
		}
		d-=sz;
		s-=sz;
		switch (sz)
		{
			case 15: d[14]=s[14];
			case 14: d[13]=s[13];
			case 13: d[12]=s[12];
			case 12: d[11]=s[11];
			case 11: d[10]=s[10];
			case 10: d[9]=s[9];
			case 9: d[8]=s[8];
			case 8: d[7]=s[7];
			case 7: d[6]=s[6];
			case 6: d[5]=s[5];
			case 5: d[4]=s[4];
			case 4: d[3]=s[3];
			case 3: d[2]=s[2];
			case 2: d[1]=s[1];
			case 1: d[0]=s[0];
			case 0:;
		}
	}
	return d;
}

/* Copy the block of 'sz' bytes beginning at 's' to 'd'.  If 'sz' is zero or
 * if 's'=='d', nothing happens.  The bytes at the lowest address ('s')
 * are copied before the ones at the highest ('s'+'sz'-1) are.
 */

char *mfwrd(register char *d, register char *s, register int sz)
{
	char *od=d;

	if (d==s)
		return d;
	if (((int) d&3)==((int) s&3) && sz>=16 )
	{
		int z=((int) s&3);

		if (z)
		{
			s-=z;
			d-=z;
			switch (4-z)
			{
				case 3: d[1]=s[1];
				case 2: d[2]=s[2];
				case 1: d[3]=s[3];
				case 0:;
			}
			s+=4;
			d+=4;
			sz-=4-z;
		}
		mfwrdI ((int *) d, (int *) s, sz>>2);
		s+=sz-3;
		d+=sz-3;
		switch (sz&3)
		{
			case 3: d[0]=s[0];
			case 2: d[1]=s[1];
			case 1: d[2]=s[2];
			case 0:;
		}
	}
	else
	{
		while (sz>=16)
		{
			d[0]=s[0]; d[1]=s[1]; d[2]=s[2]; d[3]=s[3]; d[4]=s[4]; d[5]=s[5]; d[6]=s[6];
			d[7]=s[7]; d[8]=s[8]; d[9]=s[9]; d[10]=s[10]; d[11]=s[11]; d[12]=s[12];
			d[13]=s[13]; d[14]=s[14]; d[15]=s[15];
			s+=16;
			d+=16;
			sz-=16;
		}
		s-=15-sz;
		d-=15-sz;
		switch (sz)
		{
			case 15: d[0]=s[0];
			case 14: d[1]=s[1];
			case 13: d[2]=s[2];
			case 12: d[3]=s[3];
			case 11: d[4]=s[4];
			case 10: d[5]=s[5];
			case 9: d[6]=s[6];
			case 8: d[7]=s[7];
			case 7: d[8]=s[8];
			case 6: d[9]=s[9];
			case 5: d[10]=s[10];
			case 4: d[11]=s[11];
			case 3: d[12]=s[12];
			case 2: d[13]=s[13];
			case 1: d[14]=s[14];
			case 0:;
		}
	}
	return od;
}

/* Utility to count number of lines within a segment */

int mcnt(register char *blk, register char c, int size)
{
	register int nlines=0;

	while (size>=16)
	{
		if (blk[0]==c) ++nlines;
		if (blk[1]==c) ++nlines;
		if (blk[2]==c) ++nlines;
		if (blk[3]==c) ++nlines;
		if (blk[4]==c) ++nlines;
		if (blk[5]==c) ++nlines;
		if (blk[6]==c) ++nlines;
		if (blk[7]==c) ++nlines;
		if (blk[8]==c) ++nlines;
		if (blk[9]==c) ++nlines;
		if (blk[10]==c) ++nlines;
		if (blk[11]==c) ++nlines;
		if (blk[12]==c) ++nlines;
		if (blk[13]==c) ++nlines;
		if (blk[14]==c) ++nlines;
		if (blk[15]==c) ++nlines;
		blk+=16;
		size-=16;
	}
	switch (size)
	{
		case 15: if (blk[14]==c) ++nlines;
		case 14: if (blk[13]==c) ++nlines;
		case 13: if (blk[12]==c) ++nlines;
		case 12: if (blk[11]==c) ++nlines;
		case 11: if (blk[10]==c) ++nlines;
		case 10: if (blk[9]==c) ++nlines;
		case 9: if (blk[8]==c) ++nlines;
		case 8: if (blk[7]==c) ++nlines;
		case 7: if (blk[6]==c) ++nlines;
		case 6: if (blk[5]==c) ++nlines;
		case 5: if (blk[4]==c) ++nlines;
		case 4: if (blk[3]==c) ++nlines;
		case 3: if (blk[2]==c) ++nlines;
		case 2: if (blk[1]==c) ++nlines;
		case 1: if (blk[0]==c) ++nlines;
		case 0:;
	}
	return nlines;
}
