#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <dos.h>
#include <dir.h>
#include <pc.h>
#include <bios.h>

#include "blocks.h"
#include "macro.h"
#include "va.h"
#include "vs.h"
#include "zstr.h"
#include "io.h"

int skiptop, breakflg, dirstate;
char *dirpath;

int color[]=
{
	0x02, 0x4e, 0x09, 0x02, 0x0a, 0x02, 0x02, 0x02,
	0x07, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,
	0x04, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,
	0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02
};

struct direct
{
	char d_name[16];
} direc;

struct ffblk ffblk;

SCRN *nopen()
{
	union REGS regs;
	SCRN *t=(SCRN *) malloc(sizeof(SCRN));

	regs.x.ax=0x3300;
	int86 (0x21, &regs, &regs);
	breakflg=regs.h.dl;
	regs.x.dx=0;
	regs.x.ax=0x3301;
	int86 (0x21, &regs, &regs);
	t->li=ScreenRows();
	t->co=ScreenCols();
	if ((int) ScreenPrimary==0xe00b0000)
	{
		int c;

		for (c=0; c<32; color[c++]=0x07);
		color[1]=color[8]=0x70;
		color[2]=0x01;
		color[4]=0x8f;
		color[16]=0x00;
		outportb (0x3b8, inportb(0x3b8)&0xdf);
	}
	t->updtab=malloc(t->li*sizeof(int));
	t->sary=malloc(t->li*sizeof(int));
	msetI (t->updtab+skiptop, -1, t->li-skiptop);
	return t;
}

void eraeol(SCRN *t, int x, int y)
{
	while (x<=t->co)
		ScreenPutChar (' ', color[NORMAL], x++, y);
	return;
}

void nclose(SCRN *t)
{
	union REGS regs;

	ScreenSetCursor (t->li-1, 0);
	eraeol (t, 0, t->li-1);
	free (t);
	regs.x.dx=breakflg;
	regs.x.ax=0x3301;
	int86 (0x21, &regs, &regs);
	return;
}

int getch()
{
	static int pfx=0;
	static int pfxc;
	unsigned c;

	if (pfx)
	{
		pfx=0;
		return pfxc;
	}
	c=bioskey(0);
	if ((c&255)==0)
	{
		pfx=1;
		pfxc=(c>>8);
		return 0;
	}
	else
		return (c&255);
}

void bell()
{
	sound (380);
	usleep (80000U);
	nosound ();
	usleep (30000U);
	return;
}

/* Create a KBD */

KBD *mkkbd(KMAP *kmap)
{
	KBD *kbd=(KBD *) malloc(sizeof(KBD));
	kbd->topmap=kmap;
	kbd->curmap=kmap;
	kbd->x=0;
	return kbd;
}

/* Process next key for KBD */

void *dokey(KBD *kbd, int n)
{
	void *bind=0;

/* If we were passed a negative character */
	if (n<0)
		n+=256;
/* If we're starting from scratch, clear the keymap sequence buffer */
	if (kbd->curmap==kbd->topmap)
		kbd->x=0;
	if (kbd->curmap->keys[n].k==1)
	{                         /* A prefix key was found */
		kbd->seq[kbd->x++]=n;
		kbd->curmap=kbd->curmap->keys[n].value.submap;
	}
	else
	{                         /* A complete key sequence was entered or an unbound key was found */
		bind=kbd->curmap->keys[n].value.bind;
		kbd->x=0;
		kbd->curmap=kbd->topmap;
	}
	return bind;
}

/* Return key code for key name or -1 for syntax error */

static int keyval(char *s)
{
	if (s[0]=='^' && s[1] && !s[2])
		if (s[1]=='?')
			return 127;
	else
		return s[1]&0x1F;
	else if ((s[0]=='S'||s[0]=='s') && (s[1]=='P'||s[1]=='p') && !s[2])
		return ' ';
	else if (s[1] || !s[0])
		return -1;
	else
		return (unsigned char)s[0];
}

/* Create an empty keymap */

KMAP *mkkmap()
{
	KMAP *kmap=(KMAP *) calloc(sizeof(KMAP), 1);
	return kmap;
}

/* Eliminate a keymap */

void rmkmap(KMAP *kmap)
{
	int x;

	if (!kmap)
		return;
	for (x=0; x!=KEYS; ++x)
		if (kmap->keys[x].k==1)
			rmkmap (kmap->keys[x].value.submap);
	free (kmap);
	return;
}

/* Parse a range */

static char *range(char *seq, int *vv, int *ww)
{
	char c;
	int x, v, w;

                              /* Skip to a space */
	for (x=0; seq[x] && seq[x]!=' '; ++x);
	c=seq[x];
	seq[x]=0;                 /* Zero terminate the string */
	v=keyval(seq);            /* Get key */
	w=v;
	if (w<0)
		return 0;
	seq[x]=c;                 /* Restore the space or 0 */
                              /* Skip over spaces */
	for (seq+=x; *seq==' '; ++seq);
/* Check for 'TO ' */
	if ((seq[0]=='T' || seq[0]=='t') && (seq[1]=='O' || seq[1]=='o') && seq[2]==' ')
	{
                              /* Skip over spaces */
		for (seq+=2; *seq==' '; ++seq);
                              /* Skip to space */
		for (x=0; seq[x] && seq[x]!=' '; ++x);
		c=seq[x];
		seq[x]=0;             /* Zero terminate the string */
		w=keyval(seq);        /* Get key */
		if (w<0)
			return 0;
		seq[x]=c;             /* Restore the space or 0 */
                              /* Skip over spaces */
		for (seq+=x; *seq==' '; ++seq);
	}
	if (v>w)
		return 0;
	*vv=v;
	*ww=w;
	return seq;
}

/* Add a binding to a keymap */

static KMAP *kbuild(KMAP *kmap, char *seq, void *bind, int *err, char *capseq, int seql)
{
	int v, w;

	if (!seql && seq[0])
	{
		int x, c;

		for (x=0; seq[x] && seq[x]!=' ' && seq[x]!='	'; ++x);
		c=seq[x];
		seq[x]=0;
		if (!zcmp(seq, "LEFT")) capseq="\0K", seql=2;
		else if (!zcmp(seq, "RIGHT")) capseq="\0M", seql=2;
		else if (!zcmp(seq, "UP")) capseq="\0H", seql=2;
		else if (!zcmp(seq, "DOWN")) capseq="\0P", seql=2;
		else if (!zcmp(seq, "INS")) capseq="\0R", seql=2;
		else if (!zcmp(seq, "DEL")) capseq="\0S", seql=2;
		else if (!zcmp(seq, "HOME")) capseq="\0G", seql=2;
		else if (!zcmp(seq, "END")) capseq="\0O", seql=2;
		else if (!zcmp(seq, "PGUP")) capseq="\0I", seql=2;
		else if (!zcmp(seq, "PGDN")) capseq="\0Q", seql=2;
		else if (!zcmp(seq, "F1")) capseq="\0;", seql=2;
		else if (!zcmp(seq, "F2")) capseq="\0<", seql=2;
		else if (!zcmp(seq, "F3")) capseq="\0=", seql=2;
		else if (!zcmp(seq, "F4")) capseq="\0>", seql=2;
		else if (!zcmp(seq, "F5")) capseq="\0?", seql=2;
		else if (!zcmp(seq, "F6")) capseq="\0@", seql=2;
		else if (!zcmp(seq, "F7")) capseq="\0A", seql=2;
		else if (!zcmp(seq, "F8")) capseq="\0B", seql=2;
		else if (!zcmp(seq, "F9")) capseq="\0C", seql=2;
		else if (!zcmp(seq, "F10")) capseq="\0D", seql=2;
		else if (!zcmp(seq, "^LEFT")) capseq="\0s", seql=2;
		else if (!zcmp(seq, "^RIGHT")) capseq="\0t", seql=2;
		else if (!zcmp(seq, "^HOME")) capseq="\0w", seql=2;
		else if (!zcmp(seq, "^END")) capseq="\0u", seql=2;
		else if (!zcmp(seq, "^PGUP")) capseq="\0\x84", seql=2;
		else if (!zcmp(seq, "^PGDN")) capseq="\0v", seql=2;
		else if (!zcmp(seq, "^F1")) capseq="\0^", seql=2;
		else if (!zcmp(seq, "^F2")) capseq="\0_", seql=2;
		else if (!zcmp(seq, "^F3")) capseq="\0`", seql=2;
		else if (!zcmp(seq, "^F4")) capseq="\0a", seql=2;
		else if (!zcmp(seq, "^F5")) capseq="\0b", seql=2;
		else if (!zcmp(seq, "^F6")) capseq="\0c", seql=2;
		else if (!zcmp(seq, "^F7")) capseq="\0d", seql=2;
		else if (!zcmp(seq, "^F8")) capseq="\0e", seql=2;
		else if (!zcmp(seq, "^F9")) capseq="\0f", seql=2;
		else if (!zcmp(seq, "^F10")) capseq="\0g", seql=2;
		seq[x]=c;
		if (seql)
			for (seq+=x; *seq==' '; ++seq);
	}
	if (seql)
	{
		v=w=(unsigned char) *capseq++;
		--seql;
	}
	else
	{
		seq=range(seq, &v, &w);
		if (!seq)
		{
			*err=-1;
			return kmap;
		}
	}
	if (!kmap)
		kmap=mkkmap();        /* Create new keymap if 'kmap' was NULL */
/* Make bindings between v and w */
	while (v<=w)
	{
		if (*seq || seql)
		{
			if (kmap->keys[v].k==0)
				kmap->keys[v].value.submap=0;
			kmap->keys[v].k=1;
			kmap->keys[v].value.submap=kbuild(kmap->keys[v].value.bind, seq, bind, err, capseq, seql);
		}
		else
		{
			if (kmap->keys[v].k==1)
				rmkmap(kmap->keys[v].value.submap);
			kmap->keys[v].k=0;
/* This bit of code sticks the key value in the macro */
			kmap->keys[v].value.bind=(v==w ? macstk(bind, v) : dupmacro(macstk(bind, v)));
		}
		++v;
	}
	return kmap;
}

int kadd(KMAP *kmap, char *seq, void *bind)
{
	int err=0;

	kbuild (kmap, seq, bind, &err, NULL, 0);
	return err;
}

void kcpy(KMAP *dest, KMAP *src)
{
	int x;

	for (x=0; x!=KEYS; ++x)
		if (src->keys[x].k==1)
	{
		if (dest->keys[x].k!=1)
		{
			dest->keys[x].k=1;
			dest->keys[x].value.submap=mkkmap();
		}
		kcpy (dest->keys[x].value.submap, src->keys[x].value.submap);
	}
	else if (src->keys[x].k==0 && src->keys[x].value.bind)
	{
		if (dest->keys[x].k==1)
			rmkmap(dest->keys[x].value.submap);
		dest->keys[x].value.bind=src->keys[x].value.bind;
		dest->keys[x].k=0;
	}
	return;
}

/* Remove a binding from a keymap */
int kdel(KMAP *kmap, char *seq)
{
	int err=1;
	int v, w;

	seq=range(seq, &v, &w);
	if (!seq)
		return -1;
/* Clear bindings between v and w */
	while (v<=w)
	{
		if (*seq)
		{
			if (kmap->keys[v].k==1)
			{
				int r=kdel(kmap->keys[v].value.submap, seq);

				if (err!=-1)
					err=r;
			}
		}
		else
		{
			if (kmap->keys[v].k==1)
				rmkmap(kmap->keys[v].value.submap);
			kmap->keys[v].k=0;
			kmap->keys[v].value.bind=0;
			if (err!=-1)
				err=0;
		}
		++v;
	}
	return err;
}

char *joesep(char *path)
{
	int x;

	for (x=0; path[x]; ++x)
		if (path[x]=='\\')
			path[x]='/';
	return path;
}

char *namprt(char *path)
{
	char *z;

	z=path+slen(path);
	while (z!=path && z[-1]!='/' && z[-1]!='\\' && z[-1]!=':')
		--z;
	return vsncpy(NULL, 0, sz(z));
}

char *dirprt(char *path)
{
	char *b=path;
	char *z=path+slen(path);

	while (z!=b && z[-1]!='/' && z[-1]!='\\' && z[-1]!=':')
		--z;
	return vsncpy(NULL, 0, path, z-path);
}

char *begprt(char *path)
{
	char *z=path+slen(path);

	while (z!=path && (z[-1]=='/' || z[-1]=='\\' || z[-1]==':'))
		--z;
	if (z==path)
		return vsncpy(NULL, 0, sz(path));
	else
	{
		while (z!=path && z[-1]!='/' && z[-1]!='\\' && z[-1]!=':')
			--z;
		return vsncpy(NULL, 0, path, z-path);
	}
}

char *endprt(char *path)
{
	char *z=path+slen(path);

	while (z!=path && (z[-1]=='/' || z[-1]=='\\' || z[-1]==':'))
		--z;
	if (z==path)
		return vsncpy(NULL, 0, sc(""));
	else
	{
		while (z!=path && z[-1]!='/' && z[-1]!='\\' && z[-1]!=':')
			--z;
		return vsncpy(NULL, 0, sz(z));
	}
}

int rmatch(char *a, char *b)
{
	int flag, inv, c;

	for (;;)
		switch (*a)
		{
			case '*':
				++a;
				do
					if (rmatch(a, b))
						return 1;
				while (*b++);
				return 0;
			case '[':
				++a;
				flag=0;
				if (*a=='^')
					++a, inv=1;
				else
					inv=0;
				if (*a==']')
					if (*b==*a++)
						flag=1;
				while (*a && (c= *a++)!=']')
					if (c=='-' && a[-2]!='[' && *a)
					{
						if (*b>=a[-2] && *b<=*a)
							flag=1;
					}
					else if (*b==c)
						flag=1;
				if ((!flag && !inv) || (flag && inv) || !*b)
					return 0;
				++b;
				break;
			case '?':
				++a;
				if (!*b)
					return 0;
				++b;
				break;
			case 0:  
				if (!*b)
					return 1;
				else
					return 0;
			default: 
				if (*a++!=*b++)
					return 0;
		}
}

int isreg(char *s)
{
	int x;

	for (x=0; s[x]; ++x)
		if (s[x]=='*' || s[x]=='?' || s[x]=='[')
			return 1;
	return 0;
}

void *opendir(char *path)
{
	dirstate=0;
	return &direc;
}

struct direct *readdir()
{
	int x;

	if (dirstate)
	{
		if (findnext(&ffblk))
			return 0;
	}
	else
	{
		if (findfirst("*.*", &ffblk, FA_DIREC))
			return 0;
		dirstate=1;
	}
	zcpy (direc.d_name, ffblk.ff_name);
	for (x=0; direc.d_name[x]; ++x)
		direc.d_name[x]=todn(direc.d_name[x]);
	return &direc;
}

char **rexpnd(char *word)
{
	void *dir;
	char **lst=0;
	struct direct *de;

	dir=opendir(".");
	if (dir)
	{
		while ((de=readdir(dir)))
			if (zcmp(".", de->d_name))
				if (rmatch(word, de->d_name))
					lst=vaadd(lst, vsncpy(NULL, 0, sz(de->d_name)));
	}
	return lst;
}

int chddir(char *path)
{
	int ret, tmplen;
	char *tmppath;

	if (!path[0])
		return 0;
	if (path[1]==':')
		if (path[2]=='/' || path[2]=='\\') 
		{
			setdisk (toup(path[0])-'A');
			path+=2;
		}
		else
			return -1;
	joesep (path);
	tmppath=zdup(path);
	tmplen=zlen(tmppath);
	if (tmppath[tmplen-1]=='/' && tmplen!=1)
		tmppath[tmplen-1]=0;
	ret=chdir(tmppath);
	free (tmppath);
	return ret;
}
