#include <stdio.h>
#include <fcntl.h>
#include <pc.h>

#include "io.h"
#include "help.h"
#include "macro.h"
#include "rc.h"
#include "tw.h"
#include "vfile.h"
#include "vs.h"
#include "w.h"
#include "main.h"

extern int mid, force, help, pgamnt, nobackups, lightoff,
exask, skiptop, staen, staupd, marking, beep;

int help;                     /* Set to have help on when starting */
int nonotice;                 /* Set to prevent copyright notice */
int orphan;
int leave;
int dostaupd=1;
char *exmsg;                  /* Message to display when exiting the editor */
SCREEN *maint;                /* Main edit screen */

static int ungot=0;
static int ungotc=0;

/* Make windows follow cursor */

void dofollows()
{
	W *w=maint->curwin;

	do
	{
		if (w->y!=-1 && w->watom->follow && w->object)
			w->watom->follow(w->object);
		w=(W *) (w->link.next);
	} while (w!=maint->curwin);
}

/* Update screen */

void edupd(int flg)
{
	W *w;

	if (dostaupd)
		staupd=1, dostaupd=0;
	dofollows ();
	dsphlp (maint);
	w=maint->curwin;
	do
	{
		if (w->y!=-1)
		{
			if (w->object && w->watom->disp) w->watom->disp(w->object, flg);
			msgout (w);
		}
		w=(W *) (w->link.next);
	}
	while (w!=maint->curwin);
	ScreenSetCursor (maint->curwin->y+maint->curwin->cury, maint->curwin->x+maint->curwin->curx);
	staupd=0;
	return;
}

void nungetc(int c)
{
	if (c!='C'-'@' && c!='M'-'@')
	{
		chmac ();
		ungot=1;
		ungotc=c;
	}
	return;
}

int edloop(int flg)
{
	int term=0;
	int ret=0;

	if (flg)
		if (maint->curwin->watom->what==TYPETW)
			return 0;
	else
		maint->curwin->notify=&term;
	while (!leave && (!flg || !term))
	{
		MACRO *m;
		int c;

		if (exmsg && !flg)
		{
			vsrm (exmsg);
			exmsg=0;
		}
		edupd (1);
		if (ungot)
			c=ungotc, ungot=0;
		else
			c=getch();
		m=dokey(maint->curwin->kbd, c);
		if (maint->curwin->main && maint->curwin->main!=maint->curwin)
		{
			int x=maint->curwin->kbd->x;

			maint->curwin->main->kbd->x=x;
			if (x)
				maint->curwin->main->kbd->seq[x-1]=maint->curwin->kbd->seq[x-1];
		}
		if (m)
			ret=exemac(m);
	}
	if (term ==-1)
		return -1;
	else
		return ret;
}

int main(int argc, char *argv[])
{
	char *s=NULL;
	SCRN *n;
	int opened=0;
	int omid;
	int backopt;
	int c;

	_fmode=O_BINARY;
	c=procrc("joe.ini");
	if (c==0)
		goto donerc;
	if (c==1)
	{
		char buf[8];
		fprintf (stderr, "\nThere were errors in 'joe.ini'.  Use it anyway?");
		fflush (stderr);
		fgets (buf, 8, stdin);
		if (buf[0]=='y' || buf[0]=='Y')
			goto donerc;
	}
	s=vsncpy(NULL, 0, sv(dirprt(argv[0])));
	s=vsncpy(sv(s), sc("joe.ini"));
	c=procrc(s);
	if (c==0)
		goto donerc;
	if (c==1)
	{
		char buf[8];
		fprintf (stderr, "\nThere were errors in '%s'.  Use it anyway?", s);
		fflush (stderr);
		fgets (buf, 8, stdin);
		if (buf[0]=='y' || buf[0]=='Y')
			goto donerc;
	}
	if (c==-1)
		fprintf (stderr, "Couldn't open '%s'\n", s);
	exit (1);
donerc:
	if (s)
		vsrm (s);
	izhelp ();
	for (c=1; argv[c]; ++c)
		if (argv[c][0]=='-')
			if (argv[c][1])
				switch(glopt(argv[c]+1, argv[c+1], NULL, 1))
				{
					case 0:
						fprintf (stderr, "Unknown option '%s'\n", argv[c]);
						break;
					case 1:
						break;
					case 2:
						++c;
						break;
				}
	n=nopen();
	maint=screate(n);
	vmem=vtmp();
	for (c=1, backopt=0; argv[c]; ++c)
		if (argv[c][0]=='+' && argv[c][1])
		{
		if (!backopt)
			backopt=c;
		}
	else if (argv[c][0]=='-' && argv[c][1])
	{
		if (!backopt)
			backopt=c;
		if (glopt(argv[c]+1, argv[c+1], NULL, 0)==2)
			++c;
	}
	else
	{
		B *b=bfind(argv[c]);
		BW *bw=0;
		int er=error;

		if (!orphan || !opened)
		{
			bw=wmktw(maint, b);
			if (er)
				msgnwt (bw, msgs[5+er]);
		}
		else
			b->orphan=1;
		if (bw)
		{
			int lnum=0;

			bw->o.readonly=bw->b->rdonly;
			if (backopt)
				while (backopt!=c)
					if (argv[backopt][0]=='+')
					{
						sscanf (argv[backopt]+1, "%d", &lnum);
						++backopt;
					}
					else if (glopt(argv[backopt]+1, argv[backopt+1], &bw->o, 0)==2)
						backopt+=2;
					else
						backopt+=1;
			bw->b->o=bw->o;
			bw->b->rdonly=bw->o.readonly;
			maint->curwin=bw->parent;
			if (er==-1 && bw->o.mnew)
				exemac (bw->o.mnew);
			if (er==0 && bw->o.mold)
				exemac (bw->o.mold);
			if (lnum>0)
				pline (bw->cursor, lnum-1);
		}
		opened=1;
		backopt=0;
	}
	if (opened)
	{
		wshowall (maint);
		omid=mid;
		mid=1;
		dofollows ();
		mid=omid;
	}
	else
	{
		BW *bw=wmktw(maint, bfind(""));
		if (bw->o.mnew)
			exemac(bw->o.mnew);
	}
	maint->curwin=maint->topwin;
	if (help)
		helpon (maint);
	if (!nonotice)
		msgnw (lastw(maint)->object, "\\i* Joe's Own Editor for MS-DOS v1.0 ** (C) 1995 Joseph H. Allen, Zlatko Calusic *\\i");
	edloop (0);
	vclose (vmem);
	nclose (n);
	if (exmsg)
		fprintf (stderr, "\n%s\n", exmsg);
	exit (0);
}
