#include <stdio.h>
#include <stdlib.h>
#include <limits.h>

#include "b.h"
#include "bw.h"
#include "main.h"
#include "pw.h"
#include "tab.h"
#include "ufile.h"
#include "usearch.h"
#include "vs.h"
#include "w.h"
#include "zstr.h"
#include "misc.h"

int npos;
void *QUEUE, *ITEM, *LAST;
static HENTRY *freentry=0;

typedef struct stditem STDITEM;
typedef struct pos POS;

struct stditem
{
	LINK(STDITEM) link;
};

struct pos
{
	LINK(POS) link;
	P *p;
	W *w;
};

POS pos=
{
	{
		&pos, &pos
	}
};

POS frpos=
{
	{
		&frpos, &frpos
	}
};

POS *curpos=&pos;

void *alitem(STDITEM *freelist, int itemsize)
{
	if (qempty(STDITEM, link, freelist))
	{
		STDITEM *i=(STDITEM *) malloc(itemsize*16);
		STDITEM *z=(STDITEM *) ((char *) i+itemsize*16);
		while (i!=z)
		{
			(void) enquef (STDITEM, link, freelist, i);
			i=(STDITEM *) ((char *) i+itemsize);
		}
	}
	return (void *) deque(STDITEM, link, freelist->link.prev);
}

void frchn(STDITEM *freelist, STDITEM *chn)
{
	STDITEM *i;

	if ((i=chn->link.prev)!=chn)
	{
		(void) deque (STDITEM, link, chn);
		(void) splicef (STDITEM, link, freelist, i);
	}
}

unsigned hash(char *s)
{
	unsigned accu=0;

	while (*s)
		accu=hnext(accu, *s++);
	return accu;
}

HASH *htmk(int len)
{
	HASH *t=(HASH *) malloc(sizeof(HASH));
	t->len=len-1;
	t->tab=(HENTRY **) calloc(sizeof(HENTRY *), len);
	return t;
}

void *htadd(HASH *ht, char *name, void *val)
{
	int idx=hash(name)&ht->len;
	HENTRY *entry;

	if (!freentry)
	{
		int x;

		entry=(HENTRY *) malloc(sizeof(HENTRY)*64);
		for (x=0; x!=64; ++x)
			entry[x].next=freentry, freentry=entry+x;
	}
	entry=freentry;
	freentry=entry->next;
	entry->next=ht->tab[idx];
	ht->tab[idx]=entry;
	entry->name=name;
	return entry->val=val;
}

void *htfind(HASH *ht, char *name)
{
	HENTRY *e;

	for (e=ht->tab[hash(name)&ht->len]; e; e=e->next)
		if (!zcmp(e->name, name))
			return e->val;
	return 0;
}

void markpos(W *w, P *p)
{
	POS *new=alitem((STDITEM *) &frpos, sizeof(POS));

	new->p=0;
	pdupown (p, &new->p);
	poffline (new->p);
	new->w=w;
	(void) enqueb (POS, link, &pos, new);
	if (npos==20)
	{
		new=pos.link.next;
		prm (new->p);
		(void) demote (POS, link, &frpos, new);
	}
	else
		++npos;
	return;
}

void afterpos()
{
	if (curpos!=&pos)
	{
		(void) demote (POS, link, &pos, curpos);
		curpos=&pos;
	}
	return;
}

void aftermove(W *w, P *p)
{
	if (pos.link.prev!=&pos && pos.link.prev->w==w && pos.link.prev->p && Iabs(pos.link.prev->p->line-p->line)<3)
		poffline (pset(pos.link.prev->p, p));
	else
		markpos (w, p);
	return;
}

void windie(W *w)
{
	POS *n;

	for (n=pos.link.prev; n!=&pos; n=n->link.prev)
		if (n->w==w)
			n->w=0;
	return;
}

int unextpos(BW *bw)
{
	W *w=bw->parent;

lp:
	if (curpos->link.next!=&pos && curpos!=&pos)
	{
		curpos=curpos->link.next;
		if (!curpos->p || !curpos->w)
			goto lp;
		if (w->t->curwin==curpos->w && curpos->p->byte==((BW *) w->t->curwin->object)->cursor->byte)
			goto lp;
		if (w->t->curwin!=curpos->w)
		{
			w->t->curwin=curpos->w;
			if (w->t->curwin->y==-1)
				wfit(w->t);
		}
		w=w->t->curwin;
		bw=(BW *) w->object;
		if (bw->cursor->byte!=curpos->p->byte)
			pset (bw->cursor, curpos->p);
		return 0;
	}
	else
		return -1;
}

int uprevpos(BW *bw)
{
	W *w=bw->parent;

lp:
	if (curpos->link.prev!=&pos)
	{
		curpos=curpos->link.prev;
		if (!curpos->p || !curpos->w)
			goto lp;
		if (w->t->curwin==curpos->w && curpos->p->byte==((BW *) w->t->curwin->object)->cursor->byte)
			goto lp;
		if (w->t->curwin!=curpos->w)
		{
			w->t->curwin=curpos->w;
			if (w->t->curwin->y==-1)
				wfit(w->t);
		}
		w=w->t->curwin;
		bw=(BW *) w->object;
		if (bw->cursor->byte!=curpos->p->byte)
			pset (bw->cursor, curpos->p);
		return 0;
	}
	else
		return -1;
}
