#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#include <time.h>

#include "b.h"
#include "blocks.h"
#include "bw.h"
#include "main.h"
#include "qw.h"
#include "uedit.h"
#include "ufile.h"
#include "vs.h"
#include "w.h"
#include "tw.h"

extern int square, dostaupd, skiptop;
extern char *exmsg;

int staen, staupd;

/* Move text window */

static void movetw(BW *bw, int x, int y)
{
	TW *tw=(TW *)bw->object;

	if (y || !staen)
	{
		if (!tw->staon)       /* Scroll down and shrink */
			msetI (bw->parent->t->t->updtab+skiptop, -1, bw->parent->t->t->li-skiptop);
		bwmove (bw, x+(bw->o.linums ? LINCOLS : 0), y+1);
		tw->staon=1;
	}
	else
	{
		if (tw->staon)        /* Scroll up and grow */
			msetI (bw->parent->t->t->updtab+skiptop, -1, bw->parent->t->t->li-skiptop);
		bwmove (bw, x+(bw->o.linums ? LINCOLS : 0), y);
		tw->staon=0;
	}
	return;
}

/* Resize text window */

static void resizetw(BW *bw, int wi, int he)
{
	if (bw->parent->ny || !staen)
		bwresz (bw, wi-(bw->o.linums ? LINCOLS : 0), he-1);
	else
		bwresz (bw, wi-(bw->o.linums ? LINCOLS : 0), he);
	return;
}

char *stagen(char *stalin, BW *bw, char *s, int fill)
{
	char buf[80];
	int x;
	W *w=bw->parent;

	stalin=vstrunc(stalin, 0);
	while (*s)
	{
		if (*s=='%' && s[1])
			switch (*++s)
			{
				case 't':
				{
					time_t n=time(NULL);
					char *d=ctime(&n);
					int l;

					l=(d[11]-'0')*10+d[12]-'0';
					if (l>12)
						l-=12;
					sprintf (buf, "%2.2d", l);
					if (buf[0]=='0')
						buf[0]=fill;
					stalin=vsncpy(sv(stalin), buf, 2);
					stalin=vsncpy(sv(stalin), d+13, 3);
				}
					break;
				case 'u':
				{
					time_t n=time(NULL);
					char *d=ctime(&n);

					stalin=vsncpy(sv(stalin), d+11, 5);
				}
					break;
				case 'T':
					if (bw->o.overtype)
						stalin=vsadd(stalin, 'O');
					else
						stalin=vsadd(stalin, 'I');
					break;
				case 'W':
					if (bw->o.wordwrap)
						stalin=vsadd(stalin, 'W');
					else
						stalin=vsadd(stalin, fill);
					break;
				case 'I':
					if (bw->o.autoindent)
						stalin=vsadd(stalin, 'A');
					else
						stalin=vsadd(stalin, fill);
					break;
				case 'X':
					if (square)
						stalin=vsadd(stalin, 'X');
					else
						stalin=vsadd(stalin, fill);
					break;
				case 'n':
					stalin=vsncpy(sv(stalin), sz(bw->b->name ? bw->b->name : "Unnamed"));
					break;
				case 'm':
					if (bw->b->changed)
						stalin=vsncpy(sv(stalin), sc("(Modified)"));
					break;
				case 'R':
					if (bw->b->rdonly)
						stalin=vsncpy(sv(stalin), sc("(Read only)"));
					break;
				case '*':
					if (bw->b->changed)
						stalin=vsadd(stalin, '*');
					else
						stalin=vsadd(stalin, fill);
					break;
				case 'r':
					sprintf (buf, "%-4d", bw->cursor->line+1);
					for (x=0; buf[x]; ++x)
						if (buf[x]==' ')
							buf[x]=fill;
					stalin=vsncpy(sv(stalin), sz(buf));
					break;
				case 'o':
					sprintf (buf, "%-4d", bw->cursor->byte);
					for (x=0; buf[x]; ++x)
						if (buf[x]==' ')
							buf[x]=fill;
					stalin=vsncpy(sv(stalin), sz(buf));
					break;
				case 'O':
					sprintf (buf, "%-4X", bw->cursor->byte);
					for (x=0; buf[x]; ++x)
						if (buf[x]==' ')
							buf[x]=fill;
					stalin=vsncpy(sv(stalin), sz(buf));
					break;
				case 'a':
					if (!piseof(bw->cursor))
						sprintf (buf, "%3d", 255&brc(bw->cursor));
					else
						sprintf (buf, "   ");
					for (x=0; buf[x]; ++x)
						if (buf[x]==' ')
							buf[x]=fill;
					stalin=vsncpy(sv(stalin), sz(buf));
					break;
				case 'A':
					if (!piseof(bw->cursor))
						sprintf (buf, "%2.2X", 255&brc(bw->cursor));
					else
						sprintf (buf, "  ");
					for (x=0; buf[x]; ++x)
						if (buf[x]==' ')
							buf[x]=fill;
					stalin=vsncpy(sv(stalin), sz(buf));
					break;
				case 'c':
					sprintf (buf, "%-3d", piscol(bw->cursor)+1);
					for (x=0; buf[x]; ++x)
						if (buf[x]==' ')
							buf[x]=fill;
					stalin=vsncpy(sv(stalin), sz(buf));
					break;
				case 'p':
					if (bw->b->eof->byte)
						sprintf (buf, "%3d", bw->cursor->byte*100/bw->b->eof->byte);
					else
						sprintf (buf, "100");
					for (x=0; buf[x]; ++x)
						if (buf[x]==' ')
							buf[x]=fill;
					stalin=vsncpy(sv(stalin), sz(buf));
					break;
				case 'l':
					sprintf (buf, "%-4d", bw->b->eof->line+1);
					for (x=0; buf[x]; ++x)
						if (buf[x]==' ') buf[x]=fill;
					stalin=vsncpy(sv(stalin), sz(buf));
					break;
				case 'k':
				{
					int i;
					char *cpos=buf;

					buf[0]=0;
					if (w->kbd->x && w->kbd->seq[0])
						for (i=0; i!=w->kbd->x; ++i)
						{
							int c=w->kbd->seq[i]&127;

							if (c<32)
								cpos[0]='^', cpos[1]=c+'@', cpos+=2;
							else if (c==127)
								cpos[0]='^', cpos[1]='?', cpos+=2;
							else
								cpos[0]=c, cpos+=1;
						}
					*cpos++=fill;
					while (cpos-buf<4)
						*cpos++=fill;
					stalin=vsncpy(sv(stalin), buf, cpos-buf);
				}
					break;
				case 'M':
					if (recmac)
					{
						sprintf (buf, "(Macro %d recording...)", recmac->n);
						stalin=vsncpy(sv(stalin), sz(buf));
					}
					break;
				default:
					stalin=vsadd(stalin, *s);
			}
		else
			stalin=vsadd(stalin, *s);
		++s;
	}
	return stalin;
}

static void disptw(BW *bw, int flg)
{
	W *w=bw->parent;
	TW *tw=(TW *)bw->object;

	if (bw->o.linums!=bw->linums)
	{
		bw->linums=bw->o.linums;
		resizetw (bw, w->w, w->h);
		movetw (bw, w->x, w->y);
		bwfllw (bw);
	}
	w->cury=bw->cursor->line-bw->top->line+bw->y-w->y;
	w->curx=bw->cursor->xcol-bw->offset+(bw->o.linums ? LINCOLS : 0);
	if (w->y || !staen)
	{
		int fill;

		tw->prevline=bw->cursor->line;
		tw->changed=bw->b->changed;
		if (bw->o.rmsg[0])
			fill=bw->o.rmsg[0];
		else
			fill=' ';
		tw->stalin=stagen(tw->stalin, bw, bw->o.lmsg, fill);
		tw->staright=stagen(tw->staright, bw, bw->o.rmsg, fill);
		if (fmtlen(tw->staright)<w->w)
		{
			int x=fmtpos(tw->stalin, w->w-fmtlen(tw->staright));

			if (x>sLEN(tw->stalin))
				tw->stalin=vsfill(sv(tw->stalin), fill, x-sLEN(tw->stalin));
			tw->stalin=vsncpy(tw->stalin, fmtpos(tw->stalin, w->w-fmtlen(tw->staright)), sv(tw->staright));
		}
		tw->stalin=vstrunc(tw->stalin, fmtpos(tw->stalin, w->w));
		genfmt (w->t->t, w->x, w->y, 0, tw->stalin, 0);
		w->t->t->updtab[w->y]=0;
	}
	if (flg)
		bwgen (bw, bw->o.linums);
	return;
}

/* Split current window */

void iztw(TW *tw, int y)
{
	tw->stalin=0;
	tw->staright=0;
	tw->changed=-1;
	tw->prevline=-1;
	tw->staon=(!staen || y);
	return;
}

int usplitw(BW *bw)
{
	W *w=bw->parent;
	int newh=getgrouph(w);
	W *new;
	TW *newtw;
	BW *newbw;

	dostaupd=1;
	if (newh/2<FITHEIGHT)
		return -1;
	new=wcreate(w->t, w->watom, findbotw(w), NULL, w, newh/2+(newh&1), NULL, NULL);
	if (!new)
		return -1;
	wfit (new->t);
	new->object=(void *) (newbw=bwmk(new, bw->b, 0));
	++bw->b->count;
	newbw->offset=bw->offset;
	newbw->object=(void *) (newtw=(TW *) malloc(sizeof(TW)));
	iztw (newtw, new->y);
	pset (newbw->top, bw->top);
	pset (newbw->cursor, bw->cursor);
	newbw->cursor->xcol=bw->cursor->xcol;
	new->t->curwin=new;
	return 0;
}

int uduptw(BW *bw)
{
	W *w=bw->parent;
	int newh=getgrouph(w);
	W *new;
	TW *newtw;
	BW *newbw;

	dostaupd=1;
	new=wcreate(w->t, w->watom, findbotw(w), NULL, NULL, newh, NULL, NULL);
	if (!new)
		return -1;
	if (demotegroup(w))
		new->t->topwin=new;
	new->object=(void *) (newbw=bwmk(new, bw->b, 0));
	++bw->b->count;
	newbw->offset=bw->offset;
	newbw->object=(void *) (newtw=(TW *) malloc(sizeof(TW)));
	iztw (newtw, new->y);
	pset (newbw->top, bw->top);
	pset (newbw->cursor, bw->cursor);
	newbw->cursor->xcol=bw->cursor->xcol;
	new->t->curwin=new;
	wfit (w->t);
	return 0;
}

/* User routine for aborting a text window */

int naborttw(BW *bw, int k, void *object, int *notify)
{
	W *w=bw->parent;
	B *b;
	TW *tw=(TW *)bw->object;

	if (notify)
		*notify=1;
	if (k!='y' && k!='Y')
		return -1;
	genexmsg (bw, 0, NULL);
	if (countmain(w->t)==1)
		if ((b=borphan()))
		{
			void *object=bw->object;
			bwrm (bw);
			w->object=(void *) (bw=bwmk(w, b, 0));
			wredraw (bw->parent);
			bw->object=object;
			return 0;
		}
	bwrm (bw);
	vsrm (tw->stalin);
	free (tw);
	w->object=0;
	wabort (w);                /* Eliminate this window and it's children */
	return 0;
}

static void instw(BW *bw, B *b, int l, int n, int flg)
{
	if (b==bw->b)
		bwins (bw, l, n, flg);
	return;
}

static void deltw(BW *bw, B *b, int l, int n, int flg)
{
	if (b==bw->b)
		bwdel (bw, l, n, flg);
	return;
}

static WATOM watomtw=
{
	"main",
	disptw,
	bwfllw,
	0,
	rtntw,
	utypebw,
	resizetw,
	movetw,
	instw,
	deltw,
	TYPETW
};

int uabort(BW *bw, int k)
{
	if (bw->parent->watom!=&watomtw)
		return wabort(bw->parent);
	if (bw->b->changed && bw->b->count==1)
		if (mkqw(bw, sc("Lose changes to this file (y, n, ^C)? "), naborttw, NULL, NULL, NULL))
			return 0;
		else
			return -1;
	else
		return naborttw(bw, 'y', NULL, NULL);
}

void setline(B *b, int line)
{
	W *w=maint->curwin;

	do
		if (w->watom->what==TYPETW)
		{
			BW *bw=w->object;

			if (bw->b==b)
			{
				int oline=bw->top->line;

				pline (bw->top, line);
				pline (bw->cursor, line);
				if (w->y>=0 && bw->top->line>oline && bw->top->line-oline<bw->h)
					msetI (w->t->t->updtab+skiptop, -1, w->t->t->li-skiptop);
				else if (w->y>=0 && bw->top->line<oline && oline-bw->top->line<bw->h)
					msetI (w->t->t->updtab+skiptop, -1, w->t->t->li-skiptop);
			}
		}
	while ((w=w->link.next)!=maint->curwin);
	return;
}

/* Create a text window.  It becomes the last window on the screen */

BW *wmktw(SCREEN *t, B *b)
{
	W *w;
	BW *bw;
	TW *tw;

	w=wcreate(t, &watomtw, NULL, NULL, NULL, t->h, NULL, NULL);
	wfit (w->t);
	w->object=(void *) (bw=bwmk(w, b, 0));
	bw->object=(void *) (tw=(TW *) malloc(sizeof(TW)));
	iztw (tw, w->y);
	return bw;
}
