/* Zero terminated strings */

#ifndef _Izstr
#define _Izstr 1

#define _upp 1
#define _low 2
#define _und 4
#define _bin 8
#define _oct 16
#define _dec 32
#define _hex 64
#define _flo 128

#define _whi 1
#define _eol 2
#define _eos 4

extern char _ctaB[], _ctaA[];

/* Character type test macros */

/* Upper case */
#define cupper(c) (_ctaB[(unsigned char)(c)]&_upp)

/* Lower case */
#define clower(c) (_ctaB[(unsigned char)(c)]&_low)

/* Letter */
#define calpha(c) (_ctaB[(unsigned char)(c)]&(_low|_upp))

/* First legal character of a C identifier */
#define cfirst(c) (_ctaB[(unsigned char)(c)]&(_low|_upp|_und))

/* Remaining legal characters of a C identifier */
#define crest(c)  (_ctaB[(unsigned char)(c)]&(_low|_upp|_und|_bin|_oct|_dec))

/* Binary digit */
#define cbin(c)   (_ctaB[(unsigned char)(c)]&(_bin))

/* Octal digit */
#define coct(c)   (_ctaB[(unsigned char)(c)]&(_bin|_oct))

/* Decimal digit */
#define cdec(c)   (_ctaB[(unsigned char)(c)]&(_bin|_oct|_dec))

/* Hexadecimal digit */
#define chex(c)   (_ctaB[(unsigned char)(c)]&(_bin|_oct|_dec|_hex))

/* Floating-point digit */
#define cfloat(c) (_ctaB[(unsigned char)(c)]&(_bin|_oct|_dec|_flo))

/* Whitespace: tab or space */
#define cwhite(c)  (_ctaA[(unsigned char)(c)]&(_whi))

/* Whitespace: tab, space or newline */
#define cwhitel(c) (_ctaA[(unsigned char)(c)]&(_whi|_eol))

/* Whitespace: tab, space, newline or nul */
#define cwhitef(c) (_ctaA[(unsigned char)(c)]&(_whi|_eol|_eos))

/* int Iabs(int n); Return absolute value of given int */
int Iabs();

/* int toup(int c); Convert character to uppercase if it was lowercase */
int toup();

/* int todn(int c); Convert character to lowercase if it was uppercase */
int todn();

/* int Imin(int a,int b); Return the lower integer */
int Imin();

/* int Imax(int a,int b); Return the higher integer */
int Imax();

/* int zlen(char *s); Return length of z-string */
int zlen();

/* char *zchr(char *s,char c); Return address of first 'c' in 's', or NULL if
 * the end of 's' was found first */
char *zchr(char *, char);

/* char *zcpy(char *d,char *s); Copy z-string at s to d */
char *zcpy();

/* char *zdup(char *s); Duplicate z-string into an malloc block */
char *zdup();

/* int zcmp(char *l,char *r); Compare the strings.  Return -1 if l is
 * less than r; return 0 if l equals r; and return 1 if l is greater than r.
 */
int zcmp();

#endif
